// ============================================================================
// Movo Network API Sample
//
// <CPP_ApiSample1.cpp>
//
// Copyright (c) 2008 Servoland corporation.
// All rights reserved.
//
// ړIF
//		R}hʐMs[쐬܂B
//
// VersionF					  -- ǉ, C --
//		Version 1.0		2008.08.11	: First construction.
//
// ============================================================================

#include "stdafx.h"

using namespace System;
using namespace MovoEtherVB::Servoland;

public ref class CPP_ApiSample1
{
private:
	MovoAPI^ api;
	int iDevSel;
public:
	// ========================================================================
	// 
	// ========================================================================
	int Initialize()
	{
        String^ strBuf = ""; // obt@
        int i;              // Counter
        int iRc;            // Return code
        int IFNum;          // Ethernet I/F̐
        int IFSel;          // gpEthetnet I/F
        String^ strIP = "";  // IPAhX()
        int pIP=0;          // IPAhX()
        String^ strSN = "";  // Tulbg}XN()
        int pSN=0;          // Tulbg}XN()

        api = gcnew MovoAPI(); // MovoAPINX̃CX^X

        iDevSel = 0; // ʐMfoCX=Ethernet

        // APĨo[W擾
        api->GetLibVersion(strBuf);
        strBuf = "Network API version " + strBuf + "\n";

		Console::WriteLine(strBuf);

        // I/Fݒ(Ethernetgp)
        if (iDevSel == 0)
        {
            // gp\Ethernet I/F
            IFNum = api->SearchInterface(iDevSel);
            if (IFNum < 0)
            {
				Console::WriteLine("No ethernet I/F found");
                return -1;
            }

			Console::WriteLine(IFNum.ToString() + " ethernet I/F found");

            // eI/F̏\
            for (i = 0; i < IFNum; i++)
            {
                api->GetHostIP(iDevSel, i, strIP, pIP);
                api->GetHostSN(iDevSel, i, strSN, pSN);
				Console::WriteLine(i.ToString() + " : " + String::Format("{0,-16}", strIP) + "(" + String::Format("{0,-16}", strSN) + ")");
            }

            if (IFNum == 1)
            {
                // I/FP̂Ƃ͎I
                IFSel = 0;
            }
            else
            {
                // I/FQȏ̂Ƃ̓[UI
                do
                {
                    Console::Write("Select I/F to use [0-" + (IFNum - 1).ToString() + "]> ");
                    strBuf = Console::ReadLine();
                    try
                    {
						
						IFSel = Convert::ToInt32(strBuf);
                    }
                    catch(...)
                    {
                        IFSel = -1;
                    }
                } while (IFSel < 0 || IFSel >= IFNum);

            }
            Console::WriteLine("I/F " + IFSel.ToString() + " selected\n");

            // Ethernet I/Fݒ
            api->SetInterface(iDevSel, IFSel);
        }

        // ڑꂽhCǒ
        iRc = api->SearchDevice(iDevSel, strBuf);
        if (iRc <= 0)
        {
            Console::WriteLine("No driver found");
            return -1;
        }

        // ڑ\ȂׂẴhCoɐڑ
        iRc = api->ConnectAll(iDevSel, strBuf);
        if (iRc > 0)
        {
            Console::WriteLine("Driver " + strBuf + " connected");
        }
        else
        {
            Console::WriteLine("No driver found");
            return -1;
        }
        return 0;
	}
	// ========================================================================
	// R}hʐM[
	// ========================================================================
	void Terminal()
	{
        Char ID;
        String^ strBuf;
        int iRc;

        // R}hMΏۂSɐݒ
        ID = '*';
        api->SetComID(iDevSel, ID);

		Console::WriteLine("Type command and press enter-key, or type \"quit\" to exit program");

        for(;;){
            // R}h
			Console::Write("  " + ID.ToString() + " > ");
			strBuf = Console::ReadLine();

            // ImF
            if(strBuf== "quit")
                break;
            
            // R}hM
            iRc = api->SendCom(iDevSel, strBuf);

            // MXe[^X`FbN
			if(iRc == MovoAPI::MOVO_HASDATA){
                // ԐMf[^̊l
                api->RecvCom(iDevSel, strBuf);
				Console::WriteLine("  " + ID.ToString() + " > " + strBuf);

			}else if(iRc ==MovoAPI::MOVO_FAILURE){
                // G[̊l
                api->GetErrorText(iDevSel, strBuf);
				Console::WriteLine("  Error: " + strBuf);
            }

            // ݂̃R}hMΏۂmF
            api->GetComID(iDevSel, ID);
        }
	}
};

// ============================================================================
// Gg[|Cg
// ============================================================================
int main(array<System::String ^> ^args)
{
	int iRc;
	String ^line;

	CPP_ApiSample1 sample;
	iRc=sample.Initialize();

    if(iRc != 0)
    {
        // s
		Console::WriteLine("Initialization failed (Hit Enter to exit)");
		line = Console::ReadLine();
        return -1;
    }

    sample.Terminal();
	return 0;
}
